#ifndef CONTROLPOINT_H
#define CONTROLPOINT_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

typedef struct {
	NSPoint firstHandle;
	NSRect firstHandleRect;
	NSPoint center;
	NSRect centerRect;
	NSPoint secondHandle;
	NSRect secondHandleRect;
} BezierHandle;

@class BezierPathEditor;

@interface BezierControlPoint : NSObject
{
	BezierPathEditor *myEditor;
	BezierHandle bzHandle;
	BOOL isActiveHandle;
	BOOL isSelect;
	float zmFactor;
}

- (id)initAtPoint:(NSPoint)aPoint 
		  forEditor:(BezierPathEditor *)editor
		 zoomFactor:(float)zf;
		 
- (void)calculateBezierHandles:(NSPoint)draggedHandlePosition;
- (void)moveToPoint:(NSPoint)p;
- (void)moveBezierHandleToPosition:(NSPoint)newp oldPosition:(NSPoint)oldp;

- (void)setZoomFactor:(float)f;

- (BezierHandle)bzHandle;
- (NSPoint)center;
- (NSRect)centerRect;

- (void)select;
- (void)unselect;
- (BOOL)isSelect;
- (BOOL)isActiveHandle;

@end

#endif // CONTROLPOINT_H
