#ifndef GDRAW_H
#define GDRAW_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#include "docwin.h"
#include "tools.h"

typedef enum { 
	blackarrowtool,
	whitearrowtool,
	beziertool, 
	texttool,
	circletool,
	rectangletool,
	painttool,
	penciltool,
	rotatetool,
	reducetool,
	reflecttool,
	scissorstool,
	handtool,
	magnifytool
} ToolType;

@interface GDraw : NSObject
{
	GDToolsWindow *tools;
	ToolType tooltype;
	NSMutableArray *wins;
	DocView *currentView;
	NSString *workPath;
	NSDictionary *pfbPathForFont;
}

+ (GDraw *)sharedgdraw;

- (void)setToolType:(ToolType)type;

- (ToolType)currentToolType;

- (void)setCurrentView:(DocView *)aView;

- (void)updateCurrentWindow;

- (BOOL)removeWinFromWinList:(DocWin *)awin;


- (BOOL)loadDocument:(NSString *)docPath;

- (void)new:(id)sender;

- (void)open:(id)sender;

- (void)save:(id)sender;

- (void)saveas:(id)sender;

- (void)psprint:(id)sender;

- (void)cut:(id)sender;

- (void)copy:(id)sender;

- (void)paste:(id)sender;

- (void)doUndo:(id)sender;

- (void)doRedo:(id)sender;

- (void)editObjectsProperties:(id)sender;

- (void)bringToFront:(id)sender;

- (void)sendToBack:(id)sender;

- (void)method:menuCell;


- (void)setWorkPath:(NSString *)apath;

- (NSString *)workPath;

- (NSString *)pfaDescriptionOfFont:(NSString *)fontName;

@end

#endif // GDRAW_H
