#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>
#include "gdraw.h"

void createMenu();

int main(int argc, char** argv) 
{
	id pool;
	NSApplication *theApp;

	pool = [NSAutoreleasePool new];

#if LIB_FOUNDATION_LIBRARY
  	[NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif
#ifndef NX_CURRENT_COMPILER_RELEASE
  	initialize_gnustep_backend();
#endif

	theApp = [NSApplication sharedApplication];
	[theApp setDelegate: [GDraw sharedgdraw]];  
	createMenu();
	[theApp run];
	[pool release];
	return 0;
}


void createMenu()
{
	NSMenu *menu;
	NSMenu *info;
	NSMenu *file;
	NSMenu *edit;
	NSMenu *view;
	NSMenu *util;
	NSMenu *fontMenu;
	NSMenu *services;
	NSFontManager *fontManager;
	
	SEL action = @selector(method:);
		 
	menu = [[NSMenu alloc] initWithTitle:@"GFinder"];
	[menu addItemWithTitle:@"Info" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"File" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Edit" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"View" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Utilities" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Services" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Quit" action:@selector(terminate:) keyEquivalent:@"q"];

	info = [NSMenu new];
	[info addItemWithTitle:@"Preferences..." action:action keyEquivalent:@""];
	[info addItemWithTitle:@"Preferences..." action:action keyEquivalent:@""];
	[info addItemWithTitle:@"Preferences..." action:action keyEquivalent:@""];
	[menu setSubmenu:info forItem:[menu itemWithTitle:@"Info"]];

	file = [NSMenu new];
	[file addItemWithTitle:@"New" action:@selector(new:) keyEquivalent:@"n"];
	[file addItemWithTitle:@"Open" action:@selector(open:) keyEquivalent:@"o"];
	[file addItemWithTitle:@"Save" action:@selector(save:) keyEquivalent:@"s"];
	[file addItemWithTitle:@"SaveAs" action:@selector(saveas:) keyEquivalent:@""];
	[file addItemWithTitle:@"Print" action:@selector(psprint:) keyEquivalent:@"p"];
	[menu setSubmenu:file forItem:[menu itemWithTitle:@"File"]];

	edit = [NSMenu new];
	[edit addItemWithTitle:@"Cut" action:@selector(cut:) keyEquivalent:@"x"];
	[edit addItemWithTitle:@"Copy" action:@selector(copy:) keyEquivalent:@"c"];
	[edit addItemWithTitle:@"Paste" action:@selector(paste:) keyEquivalent:@"v"];
	[edit addItemWithTitle:@"Undo" action:@selector(doUndo:) keyEquivalent:@"z"];
	[edit addItemWithTitle:@"Redo" action:@selector(doRedo:) keyEquivalent:@"r"];
	[edit addItemWithTitle:@"Properties..." action:@selector(editObjectsProperties:) keyEquivalent:@"i"];
	[edit addItemWithTitle:@"Bring to Front" action:@selector(bringToFront:) keyEquivalent:@"f"];
	[edit addItemWithTitle:@"Send to Back" action:@selector(sendToBack:) keyEquivalent:@"b"];
	[menu setSubmenu:edit forItem:[menu itemWithTitle:@"Edit"]];

	view = [NSMenu new];
	[view addItemWithTitle:@"Preferences..." action:action keyEquivalent:@""];
	[menu setSubmenu:view forItem:[menu itemWithTitle:@"View"]];

	fontManager = [NSFontManager sharedFontManager];
	fontMenu = [fontManager fontMenu: YES];

	util = [NSMenu new];
	[util addItemWithTitle:@"Preferences..." action:action keyEquivalent:@""];
	[util addItemWithTitle:@"Fonts..." action:action keyEquivalent:@""];
//	[util setSubmenu:fontMenu forItem:[util itemWithTitle:@"Fonts..."]];
	[menu setSubmenu:util forItem:[menu itemWithTitle:@"Utilities"]];

	services = [NSMenu new];
	[menu setSubmenu:services forItem:[menu itemWithTitle:@"Services"]];

	[[NSApplication sharedApplication] setMainMenu:menu];		
	[[NSApplication sharedApplication] setServicesMenu: services];
	[menu update];
	[menu display];
}
