#ifndef TEXTEDITOR_H
#define TEXTEDITOR_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

@interface TextEditorView : NSView
{
	NSView *controlsView;
	NSScrollView *scrollView;
	NSPopUpButton *fontsPopUp;
	NSTextField *sizeField;
	NSText *theText;
	NSButton *leftButt, *centerButt, *rightButt, *cancelButt, *okButt;
	int result;
	
	NSTextAlignment textAlignment;
	NSFont *font;
	int fontSize;
	float parSpace;
}

- (id)initWithFrame:(NSRect)frameRect 
		 	withString:(NSString *)string
		 	attributes:(NSDictionary *)attributes;

- (int)runModal;
			
- (void)makeFontsPopUp:(NSString *)selFontName;

- (void)changeTextAlignment:(id)sender;

- (void)changeTextFont:(id)sender;

- (void)sizeFieldDidEndEditing:(NSNotification *)notification;

- (void)okCancelPressed:(id)sender;

- (NSString *)textString;

- (NSDictionary *)textAttributes;

@end

@interface TextEditor : NSWindow
{
	TextEditorView *myView;
}

- (id)initAtPoint:(NSPoint)p 
		 withString:(NSString *)string
		 attributes:(NSDictionary *)attributes;

- (TextEditorView *)editorView;

@end

#endif // TEXTEDITOR_H
