#ifndef GDTOOLS_H
#define GDTOOLS_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

@interface GDToolButton : NSButton
{
	int tooltype;
}

- (id)initWithFrame:(NSRect)rect toolType:(int)type;
- (int)tooltype;

@end

@interface GDToolsView : NSView
{
	NSMutableArray *buttons;
	GDToolButton *barrowButt, *warrowButt, *bezierButt, *textButt;
	GDToolButton *circleButt, *rectangleButt, *paintButt, *pencilButt;
	GDToolButton *roteteButt, *reduceButt, *reflectButt, *scissorsButt;
	GDToolButton *handButt, *magnifyButt;
}

- (id)initWithFrame:(NSRect)rect;
- (void)buttonPressed:(id)sender;
- (void)setButtonsPositions:(int)ptype;

@end

@interface GDToolsWindow : NSWindow
{
	GDToolsView *toolsView;
}

- (id)init;
- (void)setButtonsPositions:(int)ptype;

@end

#endif // GDTOOLS_H
