#include "tools.h"
#include "gdraw.h"

@implementation GDToolButton

- (id)initWithFrame:(NSRect)rect toolType:(int)type
{
	self = [super initWithFrame: rect];
	if(self) {
		tooltype = type;
	}
	return self;
}

- (int)tooltype
{
	return tooltype;
}

@end

@implementation GDToolsView

- (id)initWithFrame:(NSRect)rect
{
	self = [super initWithFrame: rect];
	if(self) {
		buttons = [[NSMutableArray alloc] initWithCapacity: 14];
	
	  	barrowButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(0, 120, 25, 20)
	  														 toolType: blackarrowtool];
		[barrowButt setButtonType: NSOnOffButton];
		[barrowButt setImage: [NSImage imageNamed: @"blackarrow.tiff"]];
		[barrowButt setImagePosition: NSImageOnly];
	  	[barrowButt setTarget:self];
	  	[barrowButt setAction:@selector(buttonPressed:)];
		[self addSubview: barrowButt]; 
		[buttons addObject: barrowButt];
		[barrowButt release];
		
	  	warrowButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(25, 120, 25, 20)
	  														 toolType: whitearrowtool];
	  	[warrowButt setButtonType: NSOnOffButton];
		[warrowButt setImage: [NSImage imageNamed: @"whitearrow.tiff"]];
		[warrowButt setImagePosition: NSImageOnly];
	  	[warrowButt setTarget:self];
	  	[warrowButt setAction:@selector(buttonPressed:)];
		[self addSubview: warrowButt]; 
		[buttons addObject: warrowButt];
		[warrowButt release];

	  	bezierButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(0, 100, 25, 20)
	  														 toolType: beziertool];
	  	[bezierButt setButtonType: NSOnOffButton];
		[bezierButt setImage: [NSImage imageNamed: @"bezier.tiff"]];
		[bezierButt setImagePosition: NSImageOnly];
	  	[bezierButt setTarget:self];
	  	[bezierButt setAction:@selector(buttonPressed:)];
		[self addSubview: bezierButt]; 
		[buttons addObject: bezierButt];
		[bezierButt release];

	  	textButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(25, 100, 25, 20)
	  													  toolType: texttool];
	  	[textButt setButtonType: NSOnOffButton];
		[textButt setImage: [NSImage imageNamed: @"text.tiff"]];
		[textButt setImagePosition: NSImageOnly];
	  	[textButt setTarget:self];
	  	[textButt setAction:@selector(buttonPressed:)];
		[self addSubview: textButt]; 
		[buttons addObject: textButt];
		[textButt release];

	  	circleButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(0, 80, 25, 20)
	  														 toolType: circletool];
	  	[circleButt setButtonType: NSOnOffButton];
		[circleButt setImage: [NSImage imageNamed: @"circle.tiff"]];
		[circleButt setImagePosition: NSImageOnly];
	  	[circleButt setTarget:self];
	  	[circleButt setAction:@selector(buttonPressed:)];
		[self addSubview: circleButt]; 
		[buttons addObject: circleButt];
		[circleButt release];

	  	rectangleButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(25, 80, 25, 20)
	  														 	 toolType: rectangletool];
	  	[rectangleButt setButtonType: NSOnOffButton];
		[rectangleButt setImage: [NSImage imageNamed: @"rectangle.tiff"]];
		[rectangleButt setImagePosition: NSImageOnly];
	  	[rectangleButt setTarget:self];
	  	[rectangleButt setAction:@selector(buttonPressed:)];
		[self addSubview: rectangleButt]; 
		[buttons addObject: rectangleButt];
		[rectangleButt release];

	  	paintButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(0, 60, 25, 20)
	  														toolType: painttool];
	  	[paintButt setButtonType: NSOnOffButton];
		[paintButt setImage: [NSImage imageNamed: @"paint.tiff"]];
		[paintButt setImagePosition: NSImageOnly];
	  	[paintButt setTarget:self];
	  	[paintButt setAction:@selector(buttonPressed:)];
		[self addSubview: paintButt]; 
		[buttons addObject: paintButt];
		[paintButt release];

	  	pencilButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(25, 60, 25, 20)
	  														 toolType: penciltool];
	  	[pencilButt setButtonType: NSOnOffButton];
		[pencilButt setImage: [NSImage imageNamed: @"pencil.tiff"]];
		[pencilButt setImagePosition: NSImageOnly];
	  	[pencilButt setTarget:self];
	  	[pencilButt setAction:@selector(buttonPressed:)];
		[self addSubview: pencilButt]; 
		[buttons addObject: pencilButt];
		[pencilButt release];

	  	roteteButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(0, 40, 25, 20)
	  														 toolType: rotatetool];
	  	[roteteButt setButtonType: NSOnOffButton];
		[roteteButt setImage: [NSImage imageNamed: @"rotate.tiff"]];
		[roteteButt setImagePosition: NSImageOnly];
	  	[roteteButt setTarget:self];
	  	[roteteButt setAction:@selector(buttonPressed:)];
		[self addSubview: roteteButt]; 
		[buttons addObject: roteteButt];
		[roteteButt release];

	  	reduceButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(25, 40, 25, 20)
	  														 toolType: reducetool];
	  	[reduceButt setButtonType: NSOnOffButton];
		[reduceButt setImage: [NSImage imageNamed: @"reduce.tiff"]];
		[reduceButt setImagePosition: NSImageOnly];
	  	[reduceButt setTarget:self];
	  	[reduceButt setAction:@selector(buttonPressed:)];
		[self addSubview: reduceButt]; 
		[buttons addObject: reduceButt];
		[reduceButt release];

	  	reflectButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(0, 20, 25, 20)
	  														  toolType: reflecttool];
	  	[reflectButt setButtonType: NSOnOffButton];
		[reflectButt setImage: [NSImage imageNamed: @"reflect.tiff"]];
		[reflectButt setImagePosition: NSImageOnly];
	  	[reflectButt setTarget:self];
	  	[reflectButt setAction:@selector(buttonPressed:)];
		[self addSubview: reflectButt]; 
		[buttons addObject: reflectButt];
		[reflectButt release];

	  	scissorsButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(25, 20, 25, 20)
	  														 	toolType: scissorstool];
	  	[scissorsButt setButtonType: NSOnOffButton];
		[scissorsButt setImage: [NSImage imageNamed: @"shissors.tiff"]];
		[scissorsButt setImagePosition: NSImageOnly];
	  	[scissorsButt setTarget:self];
	  	[scissorsButt setAction:@selector(buttonPressed:)];
		[self addSubview: scissorsButt]; 
		[buttons addObject: scissorsButt];
		[scissorsButt release];

	  	handButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(0, 0, 25, 20)
	  													  toolType: handtool];
	  	[handButt setButtonType: NSOnOffButton];
		[handButt setImage: [NSImage imageNamed: @"hand.tiff"]];
		[handButt setImagePosition: NSImageOnly];
	  	[handButt setTarget:self];
	  	[handButt setAction:@selector(buttonPressed:)];
		[self addSubview: handButt]; 
		[buttons addObject: handButt];
		[handButt release];

	  	magnifyButt = [[GDToolButton alloc] initWithFrame: NSMakeRect(25, 0, 25, 20)
	  														  toolType: magnifytool];
	  	[magnifyButt setButtonType: NSOnOffButton];
		[magnifyButt setImage: [NSImage imageNamed: @"magnify.tiff"]];
		[magnifyButt setImagePosition: NSImageOnly];
	  	[magnifyButt setTarget:self];
	  	[magnifyButt setAction:@selector(buttonPressed:)];
		[self addSubview: magnifyButt]; 
		[buttons addObject: magnifyButt];
		[magnifyButt release];
		
		[barrowButt setState: NSOnState];
		[[GDraw sharedgdraw] setToolType: blackarrowtool];
	}
	return self;
}

- (void)dealloc
{
	[buttons release];
	[barrowButt release];
	[warrowButt release];
	[bezierButt release];
	[textButt release];
	[circleButt release];
	[rectangleButt release];
	[paintButt release];
	[pencilButt release];
	[roteteButt release];
	[reduceButt release];
	[reflectButt release];
	[scissorsButt release];
	[handButt release];
	[magnifyButt release];
	[super dealloc];
}

- (void)buttonPressed:(id)sender
{
	ToolType type;

	type = [(GDToolButton *)sender tooltype];
	[[GDraw sharedgdraw] setToolType: type];
}

- (void)setButtonsPositions:(int)ptype
{
	GDToolButton *butt;
	int i;

	for(i = 0; i < [buttons count]; i++) {
		butt = [buttons objectAtIndex: i];
		if([butt tooltype] != ptype)
			[butt setState: NSOffState];
		else
			[butt setState: NSOnState];
	}
}

@end


@implementation GDToolsWindow

- (id)init
{
	unsigned int style = NSTitledWindowMask;
	
	self = [super initWithContentRect: NSMakeRect(10, 400, 50, 140)
									styleMask: style
									  backing: NSBackingStoreRetained
										 defer: NO];
	if(self) {
		[self setTitle: @" "];
		toolsView = [[GDToolsView alloc] initWithFrame: NSMakeRect(0, 0, 50, 140)];
		[[self contentView] addSubview: toolsView];
		[self setFrameAutosaveName:@"GDraw_Tools"]; 
	}
	
	return self;
}

- (void)dealloc
{
	[toolsView release];
	[super dealloc];
}

- (void)setButtonsPositions:(int)ptype
{
	[toolsView setButtonsPositions: ptype];
}

@end
